/*
 * Written by Artur Biesiadowski <abies@pg.gda.pl>
 * This file is public domain - you can use/modify/distribute it as long
 * as some credit is given to me. You are not required to keep it open
 * sourced, nor to give back all changes to me, BUT if you do, everybody
 * will benefit.
 * For latest version contact me at <abies@pg.gda.pl> or check
 * http://www.gjt.org/servlets/JCVSlet/list/gjt/top.org.gjt.abies
 * This file comes with no guarantee of anything - you have been WARNED.
 */

package org.gjt.abies;

public class WaitQueue extends Queue
{

	public WaitQueue()
	{
		super();
	}

	public WaitQueue(int size)
	{
		super(size);
	}

	public synchronized void addHead(Object parm1)
	{
		super.addHead(parm1);
		if ( size() == 1 )
			notifyAll();
	}

	public synchronized void addTail(Object parm1)
	{
		super.addTail(parm1);
		if ( size() == 1 )
			notifyAll();
	}

	public synchronized Object peekHead()
	{
		try {
			while ( size() == 0 )
				wait();
		} catch (InterruptedException exc)
			{
				throw new RuntimeException(exc.toString());
			}
		return super.peekHead();
	}

	public synchronized Object removeHead()
	{
		try {
			while ( size() == 0 )
				wait();
		} catch (InterruptedException exc)
			{
				throw new RuntimeException(exc.toString());
			}
		return super.removeHead();
	}

	public synchronized Object peekTail()
	{
		try {
			while ( size() == 0 )
				wait();
		} catch (InterruptedException exc)
			{
				throw new RuntimeException(exc.toString());
			}
		return super.peekTail();
	}

	public synchronized Object removeTail()
	{
		try {
			while ( size() == 0 )
				wait();
		} catch (InterruptedException exc)
			{
				throw new RuntimeException(exc.toString());
			}
		return super.removeTail();
	}


}