
package org.gjt.abies.dialog;


import java.util.*;
import java.util.List;

import javax.swing.tree.MutableTreeNode;

import org.gjt.abies.*;
import org.gjt.abies.XmlOutput;
import org.gjt.abies.nanogroovy.*;




public abstract class TagBase  implements MutableTreeNode {

	
    public String getId() {
    	return "";
    }
    
    public String getDisplay() {
    	return "";
    }
    
    
    public String getForward() {
        return "";
    }
    
    public abstract void dumpXml(XmlOutput xml);
    
    
	
	public XMLElement getSingleChild(XMLElement root, String childName) {
		List tags = root.getChildren(childName);
		if ( tags.size() > 1) {
			throw new XMLParseException(childName,"Only one tag allowed");
		} else if ( tags.size() == 1 ) {
			return (XMLElement)tags.get(0);
		}
		return null;
	}
	
	public String getSingleChildContent(XMLElement root, String childName) {
		XMLElement xml = getSingleChild(root,childName);
		if ( xml != null ) {
			return xml.getContent();
		} else {
			return null;
		}
	}
    
    
    public static void removeFromLHM(LinkedHashMap map, int index) {
        Iterator it = map.entrySet().iterator();
        for ( int i =0; i <= index; i++ ) {
        	it.next();   
        }
        it.remove();
    }
    
    public static Object getFromLHM(LinkedHashMap map, int index) {
        Iterator it = map.values().iterator();
        for ( int i =0; i < index; i++ ) {
            it.next();   
        }
        return it.next();
    }
    
    public static int findKeyInLHM(LinkedHashMap map, Object key) {
    	int index = 0;
        Iterator it = map.keySet().iterator();
        while ( it.hasNext() ) {
        	if ( key.equals(it.next())) {
                return index;
            }
            index++;
        }
        return -1;
    }
    
    public static String nullify(String txt) {
        if ( txt != null ) {
            if ( txt.trim().length() == 0) {
                return null;
            }
        }
        return txt;
    }

	/**
	 * @return
	 */
	public String getTooltip() {
		StringBuffer sb = new StringBuffer();
        sb.append("<html>");
        sb.append("<table>");
        appendTooltipProperties(sb);
        sb.append("</table>");
        sb.append("</html>");
        return sb.toString();
	}

    public void addTooltipProperty(StringBuffer sb, String name, String value) {
        if ( value == null ) {
            return;
        } 
        value = StringUtil.replace(value,"<","&lt;");
        value = StringUtil.replace(value,"\n","<br>");
        sb.append("<tr><td><b>").append(name).append("</b></td><td>").append(value).append("</td></tr>");
        
    }

	public abstract void appendTooltipProperties(StringBuffer sb);
    
}
