package org.gjt.abies.dialog.editor;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.text.MessageFormat;

import javax.swing.*;
import javax.swing.tree.DefaultTreeCellRenderer;

import org.gjt.abies.dialog.*;
import org.gjt.abies.dialog.Dialog;



public class DialogTreeRenderer extends DefaultTreeCellRenderer {

    public static int maxDisplayLength = 20;
    /*public static String optionFormat = "%1$s->%3$s [%2$s]";
    public static String nodeFormat = "%1$s [%2$s]";
    public static String dialogFormat = "%1$s";
    */
    
    public static String optionFormat = "{0}->{2} [{1}]";
    public static String nodeFormat = "<html><b>{0}</b> [{1}]</html>";
    public static String dialogFormat = "{0}";
    
    public TagBase currentNode;
    
    
	public DialogTreeRenderer() {
		super();
	}


	public Component getTreeCellRendererComponent(JTree tree, Object value,
			boolean sel, boolean expanded, boolean leaf, int row,
			boolean hasFocus) {
        if ( value instanceof HierarchyWrapper ) {
            value = ((HierarchyWrapper)value).node;
        }
        TagBase tb = (TagBase)value;
        String fmtString = null;
        if ( tb instanceof Dialog ) {
            fmtString = dialogFormat;
        } else if ( tb instanceof Node ) {
            fmtString = nodeFormat;
        } else {
            fmtString = optionFormat;
        }
        
        StringBuffer sb = new StringBuffer();
        //Formatter fmt = new Formatter(sb);
        
        
        String display = tb.getDisplay();
        if ( display != null && display.length() > maxDisplayLength ) {
            display = display.substring(0,maxDisplayLength) + "...";
        }
        currentNode = tb;
        
        //fmt.format(fmtString,new Object[]{tb.getId(),display,tb.getForward()});
        sb.append(MessageFormat.format(fmtString,new Object[]{tb.getId(),display,tb.getForward()}));

		JLabel jl = (JLabel) super.getTreeCellRendererComponent(tree, sb, sel, expanded,
				leaf, row, hasFocus);

        
        return jl;
	}
    
    
	public String getToolTipText(MouseEvent event) {
		return currentNode.getTooltip();
	}
    
    
}
