package org.gjt.abies.dialog.editor;

import java.awt.event.*;

import javax.swing.JPopupMenu;


public class FlatTreePopup implements MouseListener {

    DialogPanel document;
    FlatTree tree;
    JPopupMenu popup;
    
    public FlatTreePopup(DialogPanel doc) {
        document = doc;
        tree = doc.flatTree;
        
        popup = new JPopupMenu();
        popup.add(document.addNode);
        popup.add(document.addOption);
        popup.addSeparator();
        popup.add(document.deleteSelected);
        
    }
    
    public void mouseClicked(MouseEvent e) {
        
        if ( e.getButton() == MouseEvent.BUTTON3) {
            // if we have clicked row selected, do nothing
            // if it is not selected, clear all and select only it
            int row = tree.getRowForLocation(e.getX(),e.getY());
            int rows[] = tree.getSelectionRows();
            if ( rows != null ) {
                for ( int i =0; i < rows.length; i++ ) {
                    if ( rows[i] == row ) {
                        row = -1;
                    }
                }
            }
            if ( row >= 0 ) {
                tree.setSelectionRow(row);
            }
            
            popup.show(tree,e.getX(),e.getY());
        }
    }

    public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {

    }

    public void mouseEntered(MouseEvent e) {

    }

    public void mouseExited(MouseEvent e) {

    }

    public static String _(String txt) {
        return txt;
    }
    
    
    
    
}
