package org.gjt.abies.dialog.editor;

import java.util.*;
import java.util.Enumeration;

import javax.swing.tree.TreeNode;

import org.gjt.abies.dialog.*;



public class HierarchyWrapper implements TreeNode {

    Dialog root;
    TagBase node;
    TreeNode parent;
    
    public HierarchyWrapper(TreeNode aParent, Dialog aRoot, TagBase aNode) {
        node = aNode;
        root = aRoot;
        parent = aParent;
    }
    
    public List getAllChildren() {
        ArrayList al = new ArrayList();
        if ( node instanceof Option ) {
            Option opt = (Option)node;
            Node n = root.findNode(opt.getForward());
            if ( n != null ) {
                al.add(new HierarchyWrapper(this,root,n));
            }
        } else if ( node instanceof Dialog ){
            Dialog dialog = (Dialog)node;
            for ( int i =0; i < dialog.getChildCount(); i++ ) {
                al.add(new HierarchyWrapper(this,root,dialog.getNode(i)));
            }
        } else if ( node instanceof Node ) {
            Node n = (Node)node;
            for ( int i =0; i < n.getChildCount(); i++ ) {
                al.add(new HierarchyWrapper(this,root,n.getOption(i)));
            }
        }
        return al;
    }
    
    public String toString() {
        return node.toString();
    }

    public int getChildCount() {
        return getAllChildren().size();
    }

    public boolean getAllowsChildren() {
        return true;
    }

    public boolean isLeaf() {
        return getChildCount() == 0;
    }

    public Enumeration children() {
        return Collections.enumeration(getAllChildren());
    }

    public TreeNode getParent() {
        return parent;
    }

    public TreeNode getChildAt(int childIndex) {
        return (TreeNode)getAllChildren().get(childIndex);
    }

    public int getIndex(TreeNode tn) {
        HierarchyWrapper hw = (HierarchyWrapper)tn;
        List children = getAllChildren();
        for ( int i =0; i < children.size(); i++ ) {
            HierarchyWrapper child = (HierarchyWrapper)children.get(i);
            if ( child.node == hw.node ) {
                return i;
            }
        }
        return -1;
    }

}
