package org.gjt.abies.dialog.editor;

import java.awt.Component;
import java.awt.event.MouseEvent;
import java.util.*;
import java.util.List;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.event.ListSelectionListener;

import org.gjt.abies.dialog.Problem;

public class ProblemPane extends JPanel implements ListSelectionListener {
    
    List currentProblems = new ArrayList();
    DialogPanel dialogPanel;
    DefaultListModel plm = new DefaultListModel();
    JList problemList = new JList(plm) {
        public String getToolTipText(MouseEvent event) {
            int index = locationToIndex(event.getPoint());
            if ( index < 0 ) {
                return null;
            }
            else {
                Problem p = (Problem)currentProblems.get(index);
                return "<html><table><tr><td><b>Problem</b>:</td><td>" + p.getDescription() + "</td></tr>" +
                        "<tr><td><b>Proposed solution:</b></td><td>" + p.getSolution() +"</td></tr></table></html>";
            }
        }
    };
    
    
    public ProblemPane(DialogPanel aPanel) {
        dialogPanel = aPanel;
        problemList.setCellRenderer(new ProblemRenderer());
        add(new JScrollPane(problemList,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_NEVER));
        problemList.setToolTipText("");
        problemList.getSelectionModel().addListSelectionListener(this);
        problemList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        problemList.setPrototypeCellValue("WWWWWWWWWWWWWWWWWWWWWW");
    }
    
    public void setProblems(List problems) {
        currentProblems = problems;
        plm.clear();
        for ( int i =0; i < currentProblems.size(); i++ ) {
            plm.addElement(currentProblems.get(i));
        }
    }
    
    
    
    
    public static class ProblemRenderer extends DefaultListCellRenderer {
        
        public Component getListCellRendererComponent(JList list, Object value,
                int index, boolean isSelected, boolean cellHasFocus) {
            return super.getListCellRendererComponent(list, value, index,
                    isSelected, cellHasFocus);
        }
    }

    public void valueChanged(ListSelectionEvent e) {
        Problem p = (Problem)problemList.getSelectedValue();
        if ( p == null ) {
            return;
        }
        dialogPanel.selectData(p.getOffendingTags());
        
    }

    
}
